'use strict';

var _componentTracker = require('./componentTracker');

var componentTracker = _interopRequireWildcard(_componentTracker);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

describe('componentTracker', function () {
  it('should be possible to track and get components', function () {
    var _expect$toEqual;

    var Component1 = function Component1() {
      return null;
    };
    var Component2 = function Component2() {
      return null;
    };

    var id1 = componentTracker.track(Component1);
    var id2 = componentTracker.track(Component2);

    expect(componentTracker.get(id1)).toBe(Component1);
    expect(componentTracker.get(id2)).toBe(Component2);

    expect(componentTracker.getAll()).toEqual((_expect$toEqual = {}, _expect$toEqual[id1] = Component1, _expect$toEqual[id2] = Component2, _expect$toEqual));
  });
});