'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _DeferredState = require('./DeferredState');

var _DeferredState2 = _interopRequireDefault(_DeferredState);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('DeferredState', function () {
  var deferredState = void 0;

  beforeEach(function () {
    deferredState = new _DeferredState2.default([0, 1, 2]);
  });

  describe('#getScriptContent', function () {
    it('should return script content', function () {
      expect(deferredState.getScriptContent()).toBe('window.__LOADABLE_COMPONENT_IDS__ = [0,1,2];');
    });
  });

  describe('#getScriptTag', function () {
    it('should return script content', function () {
      expect(deferredState.getScriptTag()).toBe('<script>window.__LOADABLE_COMPONENT_IDS__ = [0,1,2];</script>');
    });
  });

  describe('#getScriptElement', function () {
    it('should return script content', function () {
      expect((0, _enzyme.shallow)(deferredState.getScriptElement()).equals(_react2.default.createElement('script', {
        dangerouslySetInnerHTML: {
          __html: 'window.__LOADABLE_COMPONENT_IDS__ = [0,1,2];'
        }
      }))).toBe(true);
    });
  });
}); /* eslint-disable react/no-danger */